unit uDaten;

interface

uses
  windows;
const
  c_xwide=6;
  c_ywide=6;
  c_xywide=c_xwide*c_ywide;

type
  r_neighbour = record
    left, right, updown: pointer;
    dummy: integer;              // Dummy damit r_neighbour genauso gro is wie r_single
  end;

  p_neighbour= ^r_neighbour;
  r_neighbourfeld= array[1..c_xwide,1..c_ywide] of r_neighbour;

  r_single = record
    next: pointer;
    x,y,fluss:integer;
  end;

  p_single = ^r_single;
  r_feld= array[1..c_xwide,1..c_ywide] of r_single;

  r_koordinaten = record
    x,y: integer;
  end;


var
  v_data: r_feld;
  v_neighbourfeld: r_neighbourfeld;
  v_ablaufx, v_ablaufy: integer;

  v_count1,v_count2:integer;

  v_actfluss, v_maxsumme: integer;
  v_sqrttab: array[1..c_xywide] of real;

  p_datastart,p_dataend: pointer;
  p_neighbourstart,p_neighbourend: pointer;

function calcmax:integer;

function calcfluss:integer;
function calcdisp:real;

procedure connect(vp_srcpos,vp_targetpos:tpoint);
procedure disconnect(vp_srcpos:tpoint);

procedure fastdisconnect(pp_pos:p_single);

function getorient(vp_pos:tpoint):integer; // 0: Spitze nach oben

function fastfollow(pp_input:pointer):integer; // Verfolgt den Wasserflu von diesem Weg aus.
function follow(vp_pos:tpoint):integer; // Verfolgt den Wasserflu von diesem Weg aus.

function incfollow(pp_pos:p_single):tpoint;
procedure decfollow(pp_pos:p_single;vp_old:tpoint);

procedure restorexy;

procedure savefluss;
procedure restorefluss;

implementation

uses
  dialogs, sysutils,
  classes;

var
  v_bfluss:array[1..c_xwide,1..c_ywide]of integer;

function calcmax:integer;
var
  vp_run, vp_summe{,vp_maxsumme}: integer;
  pp_startpos,pp_pos:^r_single;

Label
  badend;
begin
  // Alle Wasserwege verfolgen
  pp_startpos:=@v_data;
  vp_summe:=c_xywide;
//  vp_maxsumme:=v_maxsumme;
  vp_run:=0;
  repeat
    inc(vp_run);
      if not (pp_startpos^.next=pp_startpos)
      then
        begin
          pp_pos:=pp_startpos;
          repeat
            pp_pos:=pp_pos^.next;
            inc(vp_summe);
            if (vp_summe>v_maxsumme)
            then
              goto badend;
          until (pp_pos^.next=pp_pos);
        end;
      inc(pp_startpos);
  until (vp_run=c_xywide);

  result:=vp_summe;
  exit;

badend:

  result:=0;
end;

procedure fluss;
var
  vp_run: integer;
  pp_startpos,pp_pos:^r_single;
begin
  // Reset
  pp_pos:=@v_data;
  for vp_run:= 1 to (c_xwide)*(c_Ywide)
  do
    begin
      pp_pos^.fluss:=1;
      inc(pp_pos);
    end;

  // Alle Wasserwege verfolgen
  pp_startpos:=@v_data;
  for vp_run:= 1 to c_xywide
  do
    begin
//      showmessage('Fluss: '+inttostr(vp_run));
      if not (pp_startpos^.next=pp_startpos)
      then
        begin
          if pp_startpos^.next= nil then showmessage('NIL');
          pp_pos:=pp_startpos;
          repeat
            pp_pos:=pp_pos^.next;
            inc(pp_pos^.fluss);
          until pp_pos^.next=pp_pos;
        end;
      inc(pp_startpos);
    end;

end;

function calcfluss:integer;
var
  vp_run, vp_summe: integer;
  pp_pos:^r_single;
begin
  fluss;

  // Summe bilden
  vp_summe:=0;
  pp_pos:=@v_data;
  for vp_run:= 1 to (c_xwide)*(c_Ywide)
  do
    begin
      vp_summe:=vp_summe+pp_pos^.fluss;
      inc(pp_pos);
    end;
  result:=vp_summe;
end;

function calcdisp:real;
var
  vp_run: integer;
  vp_disp:real;
  pp_startpos, pp_pos:^r_single;
begin
//  fluss;

  // Summe bilden
  vp_disp:=0;
  pp_pos:=@v_data;
  for vp_run:= 1 to (c_xwide)*(c_Ywide)
  do
    begin
//      vp_disp:=vp_disp+sqrt(pp_pos^.fluss);
      vp_disp:=vp_disp+v_sqrttab[pp_pos^.fluss];
      inc(pp_pos);
    end;
  vp_disp:=(vp_disp-v_sqrttab[c_xwide*c_ywide]);
//  vp_disp:=(vp_disp-sqrt(c_xwide*c_ywide));
  calcdisp:=vp_disp;
end;

procedure connect(vp_srcpos,vp_targetpos:tpoint);
var
  p_single: ^r_single;
begin
  p_single:=@v_data[vp_srcpos.x,vp_srcpos.y];
  p_single^.next:=@v_data[vp_targetpos.x,vp_targetpos.y];
  p_single^.x:=vp_targetpos.x;
  p_single^.y:=vp_targetpos.y;
end;

procedure disconnect(vp_srcpos:tpoint);
var
  p_single: ^r_single;
begin
  p_single:=@v_data[vp_srcpos.x,vp_srcpos.y];
  p_single^.next:=nil;
  p_single^.x:=-1;
  p_single^.y:=-1;
end;

procedure fastdisconnect(pp_pos:p_single);
begin
  pp_pos^.next:=nil;
  pp_pos^.x:=-1;
  pp_pos^.y:=-1;
end;

function getorient(vp_pos:tpoint):integer;
begin
  result:=(vp_pos.x + vp_pos.y) mod 2;
end;

{***********************************************************************}
{** Ergebnisse:                                                       **}
{** wenn das Wasser zum Ablauf fliet:       0                        **}
{** wenn der Weg des Wassers irgendwo endet: 1                        **}
{** wenn das Wasser im Kreis fliet:         2                        **}
{***********************************************************************}

function fastfollow(pp_input:pointer):integer; // Verfolgt den Wasserflu von diesem Weg aus.
asm
  mov edx, eax;     // Der Zeiger pp_input wird in edx gespeichert

@StartSchleife:
  mov eax, [eax];   // Der Zeiger .next wird in eax gespeichert

  cmp eax, 0;       // Prfen ob der Zeiger auf nil zeigt,
  je @nilEnde;      // wenn ja, sprung zu @nilEnde

  mov ecx, [eax];
  cmp edx, ecx;     // Prfen ob der Zeiger auf den ursprnglichem Zeiger zeigt
  je @Kreis;        // wenn ja, sprung zu @Kreis

  cmp eax, ecx;
  je @Ablauf;

  jmp @StartSchleife;

// Rckgabewert in eax schreiben und zum Ende springen
@Ablauf:
  mov eax, 0;
  jmp @ende;

@nilEnde:
  mov eax, 1;
  jmp @ende;

@Kreis:
  mov eax, 2;

@ende:

end; //function fastfollow(pp_input:pointer):integer;

function follow(vp_pos:tpoint):integer; // Verfolgt den Wasserflu von diesem Weg aus.
begin
  result:=fastfollow(@v_data[vp_pos.x,vp_pos.y]);
end; //function follow(vp_pos:tpoint):integer;

function incfollow(pp_pos:p_single):tpoint;
var
  vp_newfluss:integer;
  pp_startpos:p_single;
  vp_result:tpoint; // x: vp_newfluss; y: Anzahl der Schleifendurchlufe
begin
  vp_result.y:=0;
  pp_startpos:=pp_pos;
  vp_newfluss:=pp_pos^.fluss+1;
  v_actfluss:=v_actfluss-pp_pos^.fluss;
  pp_pos^.fluss:=0;
  repeat
    inc(vp_result.y);
    pp_pos^.fluss:=pp_pos^.fluss+vp_newfluss;
    pp_pos:=pp_pos^.next;
  until (pp_pos^.next=pp_pos) // Wasser hat den Ablauf erreicht
      or(pp_pos^.next=pp_startpos)   // Wasser fliet im Kreis
      or(pp_pos^.next=nil);              // Wasser hat Ende des Weges erreicht
  v_actfluss:=v_actfluss+(vp_result.y*vp_newfluss);
  v_actfluss:=v_actfluss+vp_newfluss;
  pp_pos^.fluss:=pp_pos^.fluss+vp_newfluss;
  vp_result.x:=vp_newfluss;
  if (pp_pos^.next=pp_startpos) // Wasser fliet im Kreis
  then
    begin
      decfollow(pp_startpos,vp_result);
      vp_result.x:=-1;
    end;
  result:=vp_Result;

end;

procedure decfollow(pp_pos:p_single;vp_old:tpoint);
var
  vp_newfluss:integer;
  pp_startpos:p_single;
begin
  pp_startpos:=pp_pos;
//  vp_newfluss:=pp_pos^.fluss;
  v_actfluss:=v_actfluss+vp_old.x-1;
  pp_pos^.fluss:=pp_pos^.fluss+vp_old.x-1;
  v_actfluss:=v_actfluss-(vp_old.x*vp_old.y);
  for vp_newfluss:=vp_old.y downto 1
  do
    begin
    pp_pos^.fluss:=pp_pos^.fluss-vp_old.x;
    pp_pos:=pp_pos^.next;
    end;
//    pp_pos:=pp_pos^.next;
{  repeat
  until (pp_pos^.next=pp_pos) // Wasser hat den Ablauf erreicht
      or(pp_pos^.next=pp_startpos)   // Wasser fliet im Kreis
      or(pp_pos^.next=nil);              // Wasser hat Ende des Weges erreicht}
//  if pp_pos^.next=nil then begin
    v_actfluss:=v_actfluss-vp_old.x;
    pp_pos^.fluss:=pp_pos^.fluss-vp_old.x;
//  end;
end;

procedure restorexy;
var
  vp_xrun,vp_yrun: integer;
  pp_pos: p_single;
  pp_neighbour: p_neighbour;
begin
  pp_pos:=p_datastart;
  pp_neighbour:=p_neighbourstart;
  for vp_xrun:= 1 to c_xwide do
    for vp_yrun:= 1 to c_ywide do
      begin
        pp_neighbour:=@v_neighbourfeld[vp_xrun,vp_yrun];
        pp_pos:=@v_data[vp_xrun,vp_yrun];
        if pp_neighbour^.updown=pp_pos^.next
        then // Zeigt nach oben oder unten
          begin
            pp_pos^.x:=vp_xrun;
            pp_pos^.y:=vp_yrun+pp_neighbour^.dummy;
          end;
{        if v_neighbourfeld[vp_xrun,vp_yrun].left=v_data[vp_xrun,vp_yrun].next}
        if pp_neighbour^.left=pp_pos^.next
        then // Zeigt nach links
          begin
            pp_pos^.x:=vp_xrun-1;
            pp_pos^.y:=vp_yrun;
{            v_data[vp_xrun,vp_yrun].x:=vp_xrun-1;
            v_data[vp_xrun,vp_yrun].y:=vp_yrun;}
          end;
        if pp_neighbour^.right=pp_pos^.next
        then // Zeigt nach rechts
          begin
            pp_pos^.x:=vp_xrun+1;
            pp_pos^.y:=vp_yrun;
          end;

        if (vp_xrun=v_ablaufx)and(vp_yrun=v_ablaufy)
{        then
          showmessage('Ablauf');
        if pp_pos=pp_pos^.next}
        then // Abfluss
          begin
  //          showmessage('AX:'+inttostr(v_ablaufx)+' AY:'+inttostr(v_ablaufy)+' x:'+inttostr(VP_xrun)+' y:'+inttostr(VP_yrun));
//            v_ablaufx:=vp_xrun;
//            v_ablaufy:=vp_yrun;
//            connect(point(vp_xrun,vp_yrun),point(vp_xrun,vp_yrun));
            pp_pos^.x:=vp_xrun;
            pp_pos^.y:=vp_yrun;
          end;
        inc(pp_neighbour);
        inc(pp_pos);
      end; // for schleife
end;
procedure init_neighbourfeld;
var
  vp_xrun,vp_yrun:integer;
begin
  for vp_yrun:=1 to c_ywide do
    for vp_xrun:=1 to c_xwide do
      begin
        if getorient(point(vp_xrun,vp_yrun))=0
        then // Spitze nach oben
          v_neighbourfeld[vp_xrun,vp_yrun].dummy:=1
        else
          v_neighbourfeld[vp_xrun,vp_yrun].dummy:=-1;

        // Pointer auf linkes Feld setzen
        if vp_xrun>1
          then
            v_neighbourfeld[vp_xrun,vp_yrun].left:=@v_data[vp_xrun-1,vp_yrun]
          else
            v_neighbourfeld[vp_xrun,vp_yrun].left:=nil;

        // Pointer auf rechtes Feld setzen
        if vp_xrun<c_xwide
          then
            v_neighbourfeld[vp_xrun,vp_yrun].right:=@v_data[vp_xrun+1,vp_yrun]
          else
            v_neighbourfeld[vp_xrun,vp_yrun].right:=nil;

        // Pointer Oben oder Unten setzen
        if getorient(point(vp_xrun,vp_yrun))=0   // 0: Spitze nach oben
          then   // Pointer nach unten
            if vp_yrun<c_ywide
              then
                v_neighbourfeld[vp_xrun,vp_yrun].updown:=@v_data[vp_xrun,vp_yrun+1]
              else
                v_neighbourfeld[vp_xrun,vp_yrun].updown:=nil
          else   // Pointer nach oben
            if vp_yrun>1
              then
                v_neighbourfeld[vp_xrun,vp_yrun].updown:=@v_data[vp_xrun,vp_yrun-1]
              else
                v_neighbourfeld[vp_xrun,vp_yrun].updown:=nil;
      end;
end;

procedure savefluss;
var
  vp_xrun, vp_yrun: integer;
begin
  for vp_xrun:=1 to c_xwide do
    for vp_yrun:=1 to c_ywide do
      v_bfluss[vp_xrun,vp_yrun]:=v_data[vp_xrun,vp_yrun].fluss;
end;

procedure restorefluss;
var
  vp_xrun, vp_yrun: integer;
begin
  for vp_xrun:=1 to c_xwide do
    for vp_yrun:=1 to c_ywide do
      v_data[vp_xrun,vp_yrun].fluss:=v_bfluss[vp_xrun,vp_yrun];
end;

begin
  init_neighbourfeld;
  p_datastart:=@v_data;
  p_dataend:=@v_data[c_xwide,c_ywide];

  p_neighbourstart:=@v_neighbourfeld;
  p_neighbourend:=@v_neighbourfeld[c_xwide,c_ywide];

end.
